﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

/// <summary>
/// This Factory will create Instances of the UC_1BufRow.
/// The UC_1BufRow is the container for all the Required UC's based on the Type of Buffer Row we want to visualize
/// </summary>
namespace GDYR.LULM.Wj.ProdManager.Engines
{
    public class eUC_1BufRowFactory
    {
        public delegate void BufRowCreatedHandler(object sender, UserControls.UC_1BufRow e);

        public event BufRowCreatedHandler BufRowCreatedEvent;

        //private GDYR.LULM.Wj.ProdManager.Engines.eControlColorer CtrlColorer = new eControlColorer();

        //Keep Track about the Sales Order - Sales Item being processed
        private string SO = string.Empty;
        private string SI = string.Empty;

        public void CreateBufRow()
        {
            DO_Fill_UserControl();
        }

        public void CreateBufRows(List<string> SalesOrders,List<string> ProdOrders,List<string> MERs, string _myLMORA01DbCString)
        {

            // We are creating a bunch of Rows based on the supplied Sales Orders List
            if (SalesOrders != null)
            {
                foreach (string SO in SalesOrders)
                {
                    Wisej.Web.Application.StartTask(() => { DO_Fill_UserControl(); });
                }
            }
        }

        private void DO_Fill_UserControl()
        {
            //Instanciate the Return Control
            GDYR.LULM.Wj.ProdManager.UserControls.UC_1BufRow oReturn = new UserControls.UC_1BufRow();
            oReturn.SuspendLayout();

            oReturn.Height = 97;

            UserControls.UC_Comment UC_Comment = new UserControls.UC_Comment();
            UC_Comment.SuspendLayout();

            UC_Comment.Height = 16;
            UC_Comment.Dock = Wisej.Web.DockStyle.Bottom;
            UC_Comment.ResumeLayout();

            oReturn.Controls.Add(UC_Comment);

            //OnBufRowCreatedEvent(oReturn);
            //return;

            string query = null;

            //List Of Production Order's to process (add to the BufferRow) which is (PO,PO description)
            List<KeyValuePair<string,string>> LstOfPos = new List<KeyValuePair<string, string>>();

                //Get the list of Production Order's to process for the whole Sales Order
                LstOfPos = GetListOfPO("1010121336", "20".PadLeft(6, '0'));

            //Now Start Building the GUI Row

            UserControls.UC_ColumnsA_B UC_DelivDate = new UserControls.UC_ColumnsA_B();
            UC_DelivDate.SuspendLayout();

            //ItemArray[4]=REQUIREMENT_DATE
            UC_DelivDate.Lbl_Date.Text = "09/17";

            UC_DelivDate.Lbl_SalesOrder.Text ="1011191264/10";
            UC_DelivDate.Lbl_OrderingPlant.Text = "WI/10";
            UC_DelivDate.Lbl_MER.Text = "REP NO MER";
            //ItemArray[63]=TIRE_TYPE
            UC_DelivDate.Lbl_TireType.Text = "Passenger";
            //UC_DelivDate.Lbl_Priority.Text = "SPF" ==>> Set in the ControlColorer engine;
            UC_DelivDate.Lbl_BrandName.Text = "ASSURANCE";

            //Now save this partial info to Data Object
            oReturn.oUC_1BufRowData.Column_A_B.DeliveDate = UC_DelivDate.Lbl_Date.Text;
            oReturn.oUC_1BufRowData.Column_A_B.SalesOrder = UC_DelivDate.Lbl_SalesOrder.Text;
            oReturn.oUC_1BufRowData.Column_A_B.OrderingPlant = UC_DelivDate.Lbl_OrderingPlant.Text;
            oReturn.oUC_1BufRowData.Column_A_B.MER = UC_DelivDate.Lbl_MER.Text;
            oReturn.oUC_1BufRowData.Column_A_B.TireType = UC_DelivDate.Lbl_TireType.Text;
            oReturn.oUC_1BufRowData.Column_A_B.BrandName = UC_DelivDate.Lbl_BrandName.Text;

            UC_DelivDate.Dock = Wisej.Web.DockStyle.Left;

            //Do the conditional Coloring and get the Data value for the Priority (only returned for UC_ColumnsA_B type)
            //oReturn.oUC_1BufRowData.Column_A_B.Priority = CtrlColorer.Color_UserControl(UC_DelivDate, DS);

            UC_DelivDate.ResumeLayout();

            oReturn.Controls.Add(UC_DelivDate);
            oReturn.Controls.SetChildIndex(UC_DelivDate, 0);

            int OperDetailsTotalWidth = 0;
            int _MaxOperStatusWidth = -999;
            //Now add the Production Order's Status Blocs
            //Loop through the PO List and create the Buffer Rows
            foreach (KeyValuePair<string, string> PO in LstOfPos)
            {
                //Get the List of ALerts Pertaining to this SalesOrder-SalesLine
                //FillAlerts(SO, SI.PadLeft(6, '0'), PO.Key,ref oReturn, LMORA01Db);
                //if (oReturn.oUC_1BufRowData.Alerts.AlertsList.Count > 0) { UC_Comment.UC_Lbl_Alert.ImageSource = "Images/Alert_16x16.png"; }

                //Add the Production Order Status Bloc
                UserControls.UC_OperationDetails UC_OperationDetails = new UserControls.UC_OperationDetails(PO.Key.TrimStart('0') + " / 50 " + PO.Value, GetOperationDic(), GetOperDescDic(), oReturn.oUC_1BufRowData);
                UC_OperationDetails.SuspendLayout();

                //Keep at least a minimum Width for all Blocks
                if (UC_OperationDetails.Width < 250 ) UC_OperationDetails.ResizeCtrl(250);

                UC_OperationDetails.Dock = Wisej.Web.DockStyle.Left;

                //Store the Max Width from All the UC_OperationDetails controls in this Row
                if (UC_OperationDetails.TotalOperationsWidth > _MaxOperStatusWidth){ _MaxOperStatusWidth = UC_OperationDetails.TotalOperationsWidth;}

                oReturn.Controls.Add(UC_OperationDetails);
                oReturn.Controls.SetChildIndex(UC_OperationDetails, 0); //Change Z-Order
                OperDetailsTotalWidth += UC_OperationDetails.Width;

                UC_OperationDetails.ResumeLayout();
            }

            oReturn.Width = UC_DelivDate.Width + OperDetailsTotalWidth;
            oReturn.MaxOperStatusWidth = _MaxOperStatusWidth;

            oReturn.ResumeLayout();

            //Trigger the Created Event
            OnBufRowCreatedEvent(oReturn);
        }

        //private void FillAlerts(string SO,string SI,string PO,ref GDYR.LULM.Wj.ProdManager.UserControls.UC_1BufRow oReturn, GDYR.LULM.Wj.ProdManager.Engines.eOracleLMORA01 LMORA01Db)
        //{
        //    System.Data.DataSet DS_Alerts = null;

        //    if (SO != null && SI != null && PO != null)
        //    {
        //        //Get Alerts for this SalesOrder-SalesItem-ProdOrder
        //        string query = "SELECT * FROM LMPROGS.MOLD_ALERTS where ID LIKE '" + SO + "-" + SI.PadLeft(6, '0') + "-" + PO.PadLeft(12,'0') + "-" + "%'";
        //        DS_Alerts = LMORA01Db.GetRecords(query);
        //    }
        //    else
        //    {
        //        //Get Alerts for this SalesOrder-SalesItem
        //        string query = "SELECT * FROM LMPROGS.MOLD_ALERTS where ID LIKE '" + SO + "-" + SI.PadLeft(6, '0') + "-" +"%'";
        //        DS_Alerts = LMORA01Db.GetRecords(query);
        //    }

        //    if (DS_Alerts.Tables.Count > 0) //Did we find some alert ?
        //    {
        //         foreach (System.Data.DataRow DR in DS_Alerts.Tables[0].Rows)
        //        {
        //            GDYR.LULM.LMObjects.Common.oAlert Alert = new GDYR.LULM.LMObjects.Common.oAlert();
        //            Alert.ID = DR["ID"].ToString();
        //            Alert.Code = DR["CODE"].ToString();
        //            Alert.Origin = DR["ORIGIN"].ToString();
        //            Alert.TimeStamp = DateTime.Parse(DR["TIMESTAMP"].ToString());
        //            DateTime.SpecifyKind(Alert.TimeStamp, DateTimeKind.Utc);

        //            Alert.Category = DR["CATEGORY"].ToString();
        //            Alert.ShortMessage = DR["SHORTMESSAGE"].ToString();
        //            Alert.Status = DR["STATUS"].ToString();
        //            if (DR["HASBEENREADBY"] == null) { Alert.HasBeenReadBy = (List<string>)DR["HASBEENREADBY"]; } else { Alert.HasBeenReadBy = new List<string>();}
        //            if (DR["MARKASREAD"] == null) { Alert.MarkAsRead = (List<string>)DR["MARKASREAD"]; } else { Alert.MarkAsRead = new List<string>();}
        //            Alert.AcknowledgeID = DR["ACKNOWLEDGEID"].ToString();
        //            Alert.BLOBObj = DR["BLOBOBJ"];

        //            //Create new list if required, otherwise add to the existing list
        //            if (oReturn.oUC_1BufRowData.Alerts.AlertsList == null)
        //            { oReturn.oUC_1BufRowData.Alerts.AlertsList = new List<LMObjects.Common.oAlert> { Alert }; }
        //            else
        //            { oReturn.oUC_1BufRowData.Alerts.AlertsList.Add(Alert); }
        //        }
        //    }
        //}

        /// <summary>
        /// Fill the list of Production Orders which belongs to the SalesOrder. We return the PO, the material Description
        /// </summary>
        /// <param name="SalesOrder"></param>
        /// <param name="SaleItem"></param>
        /// <returns></returns>
        private List<KeyValuePair<string,string>> GetListOfPO(string SalesOrder, string SaleItem)
        {
            List<KeyValuePair<string, string>> oReturn = new List<KeyValuePair<string, string>>();
            oReturn.Add(new KeyValuePair<string, string>("61135287", "LET BOT MD PL")); //Production Order, Material Description
            oReturn.Add(new KeyValuePair<string, string>("61135288", "MOLD SEGMENT SET")); //Production Order, Material Description
            oReturn.Add(new KeyValuePair<string, string>("61135289", "RU & RW SLIDE BLOCK SET")); //Production Order, Material Description
            oReturn.Add(new KeyValuePair<string, string>("61135286", "LET TOP MD PL")); //Production Order, Material Description
            oReturn.Add(new KeyValuePair<string, string>("61135284", "MOLD SEGMENT SET")); //Production Order, Material Description
            oReturn.Add(new KeyValuePair<string, string>("61135285", "SLUG LIST TOP")); //Production Order, Material Description
            oReturn.Add(new KeyValuePair<string, string>("61135290", "195/60R16 CWB303AA NTM RU")); //Production Order, Material Description

            return oReturn;
        }


        /// <summary>
        /// 
        /// </summary>
        /// <param name="ProductionOrder"></param>
        /// <returns></returns>
        private  string Get_PO_Description(string ProductionOrder)
        {
            return "TOP CONTAINER PLATE REP.";
        }

        /// <summary>
        /// Fill the Dictionary of Operations (Workcenter,Operation Number)
        /// </summary>
        /// <param name="DS"></param>
        /// <returns></returns>
        private List<KeyValuePair<string, string>> GetOperationDic()
        {
           List<KeyValuePair<string,string>> oReturn = new List<KeyValuePair<string, string>>();
            for (int i= 0;i < 11;i++)
            {
                //OperDic.Add((string)DR["WORKCENTER_NUMBER"],(string)DR["OPERATION_NUMBER"]);
                oReturn.Add(new KeyValuePair<string,string>("WKC"+i, (10+i).ToString().PadLeft(4,'0'))); //WORKCENTER_NUMBER, OPERATION_NUMBER
            }

            return oReturn;
        }

        /// <summary>
        /// Fill the Dictionary of Operations DESCRIPTIONS (Operation,Description)
        /// </summary>
        /// <param name="DS"></param>
        /// <returns></returns>
        private System.Collections.Specialized.NameValueCollection GetOperDescDic()
        {
            System.Collections.Specialized.NameValueCollection oReturn = new System.Collections.Specialized.NameValueCollection();
            for (int i=0;i<11;i++)
            {
                oReturn.Add((10+i).ToString().PadLeft(4,'0'), "Op Desc" + i.ToString()); //OPERATION_NUMBER, OPERATION_DESCRIPTION
            }

            return oReturn;
        }
        /// <summary>
        /// Make it Thread Safe
        /// </summary>
        /// <param name="e"></param>
        private void OnBufRowCreatedEvent(UserControls.UC_1BufRow e)
        {
            if (BufRowCreatedEvent != null)
            {
                BufRowCreatedEvent(this, e);
            }
        }
    }
}