﻿using System;
using Wisej.Web;

namespace GDYR.LULM.Wj.ProdManager.UserControls
{
    public partial class UC_1BufRow : Wisej.Web.UserControl
    {
        //Keep track which control has sent the MouseEnter Event (from User controls inside this User control)
        public object CtrlWhichRaisedMouseEnter { get; set; }

        //Keep track which control has sent the Click Event (from User controls inside this User control)
        public object CtrlWhichRaisedClick { get; set; }

        GDYR.LULM.Wj.ProdManager.Objects.oUC_1BufRow_Data _oUC_1BufRowData = null;
        public GDYR.LULM.Wj.ProdManager.Objects.oUC_1BufRow_Data oUC_1BufRowData
        {
            get
            {
                return _oUC_1BufRowData;
            }
            set
            {
                _oUC_1BufRowData = value;
            }
        }

        //Keep Track of the widest Status Control
        protected int _MaxOperStatusWidth = -999;
        public int MaxOperStatusWidth
        {
            get
            {
                return _MaxOperStatusWidth;
            }
            set
            {
                _MaxOperStatusWidth = value;
            }
        }

        public UC_1BufRow()
        {
            InitializeComponent();
            this.styleSheet1.SetCssClass(this, "box");

            //Instantiate the Data Object
            _oUC_1BufRowData = new Objects.oUC_1BufRow_Data();

            //Create the List which can store the alerts
            //_oUC_1BufRowData.Alerts.AlertsList = new System.Collections.Generic.List<LMObjects.Common.oAlert>();
        }
        public void ResizeOperStatusControls(int Width)
        {
            //Resize individual UC_OperationDetails to get them Alligned between UC_1BuffRow rows
            int TotalCtrlWidth = 0;
            foreach (Control OperCtrl in this.Controls)
            {
                if (OperCtrl is UserControls.UC_OperationDetails)
                {
                    UserControls.UC_OperationDetails oCtrl = (UserControls.UC_OperationDetails)OperCtrl;
                    if (oCtrl.Width != Width) oCtrl.ResizeCtrl(Width);
                }
                    TotalCtrlWidth += OperCtrl.Width;
            }
            //Know resize the Whole control length
            this.Width = TotalCtrlWidth;
        }

        #region To Bubble the Click Event
        protected override void OnControlAdded(ControlEventArgs e)
        {
            e.Control.Click += doclick;
            e.Control.MouseEnter += doMouseEnter;
        }

        private void doclick(object sender, EventArgs e)
        {
            CtrlWhichRaisedClick = sender;
            this.OnClick(e);
        }
        private void doMouseEnter(object sender, EventArgs e)
        {
            CtrlWhichRaisedMouseEnter = sender;
            this.OnMouseEnter(e);
        }

        protected override void OnControlRemoved(ControlEventArgs e)
        {
            e.Control.Click -= doclick;
            e.Control.MouseEnter -= doMouseEnter;
        }
        #endregion
    }
}
