﻿using System;
using Wisej.Web;

namespace GDYR.LULM.Wj.ProdManager.UserControls
{
    public partial class UC_FiltersByPeriod : Wisej.Web.UserControl
    {
        //The object keeping track of the actual selected Date
        WorkingOn.WorkingData Actual_WorkingData = null;

        public delegate void FilterSelectionChangedHandler(object sender, Objects.oBufLeftDockedFilterSelectionEvent e);
        public event FilterSelectionChangedHandler FilterSelectionChangedEvent;

        public UC_FiltersByPeriod()
        {
            InitializeComponent();
            Scroll2NewDate(DateTime.Today);
        }

        private void Radio_CheckedChanged(object sender, EventArgs e)
        {
            RadioButton RdB = (RadioButton)sender;

            //Do not treat de-selection events
            if (!RdB.Checked) { return; }

            //Raise Event (in a Thread Safe manner)
            Objects.oBufLeftDockedFilterSelectionEvent oEvent = new Objects.oBufLeftDockedFilterSelectionEvent();
            oEvent.EventText = string.Empty;
            oEvent.OnlyLate = Chk_LateOnly.Checked;

            bool SendEvent = false;
            switch (RdB.Name)
            {
                case "Radio_Today":
                    Grp_Days.BackColor = System.Drawing.Color.LightSteelBlue; Grp_Weeks.BackColor = System.Drawing.Color.FromName("@window");


                    Txt_Day.Text = DateTime.Today.Day.ToString();
                    Txt_Week.Text = GDYR.LULM.LMObjects.Common.Dates.oWeek.getCurrentWeek(DateTime.Today).Week.ToString();

                    //Branch to the Week process
                    Actual_WorkingData.WorkingDate = DateTime.Today;
                    Scroll2NewDate(new DateTime(Actual_WorkingData.WorkingYear, Actual_WorkingData.WorkingMonth, Convert.ToInt32(Txt_Day.Text)));
                    SendEvent = false;
                    //oEvent.DateRangeStart = DateTimeOffset.UtcNow.LocalDateTime.Date;
                    //oEvent.DateRangeEnd = oEvent.DateRangeStart;

                    //oEvent.EventText = "(Week : " + GDYR.LULM.LMObjects.Common.Dates.oWeek.getCurrentWeek(oEvent.DateRangeStart).Week + ") (Today : " + oEvent.DateRangeStart.ToShortDateString() + ")";

                    //SendEvent = true;
                    break;

                case "RadioTomorrow":
                    Grp_Days.BackColor = System.Drawing.Color.FromName("@window"); Grp_Weeks.BackColor = System.Drawing.Color.FromName("@window");

                    oEvent.DateRangeStart = DateTimeOffset.UtcNow.LocalDateTime.Date.AddDays(1);
                    oEvent.DateRangeEnd = oEvent.DateRangeStart;

                    oEvent.EventText = "(Week : " + GDYR.LULM.LMObjects.Common.Dates.oWeek.getCurrentWeek(oEvent.DateRangeStart).Week + ") (Tomorrow : " + oEvent.DateRangeStart.ToShortDateString() + ")";

                    SendEvent = true;
                    break;

                case "RadioUntilTomorrow":
                    Grp_Days.BackColor = System.Drawing.Color.FromName("@window"); Grp_Weeks.BackColor = System.Drawing.Color.FromName("@window");

                    oEvent.DateRangeStart = DateTimeOffset.UtcNow.LocalDateTime.Date;
                    oEvent.DateRangeEnd = oEvent.DateRangeStart.AddDays(1);

                    oEvent.EventText = "(Week : " + GDYR.LULM.LMObjects.Common.Dates.oWeek.getCurrentWeek(oEvent.DateRangeStart).Week + ") (Until Tomorrow : " + oEvent.DateRangeStart.ToShortDateString() + " - " + oEvent.DateRangeEnd.ToShortDateString() + ")";

                    SendEvent = true;
                    break;

                case "Radio_ThisWeek":
                    Grp_Weeks.BackColor = System.Drawing.Color.LightSteelBlue; Grp_Days.BackColor = System.Drawing.Color.FromName("@window");
                    //Txt_Day.Text = DateTime.Today.Day.ToString();
                    GDYR.LULM.LMObjects.Common.Dates.oWeek.oWeekOfYear WOY = GDYR.LULM.LMObjects.Common.Dates.oWeek.getCurrentWeek(DateTime.Today);
                    Txt_Week.Text =WOY.Week.ToString();

                    //Branch to the Week process
                    Actual_WorkingData.WorkingDate = WOY.MondayDate; // DateTime.Today;
                    Scroll2NewDate(new DateTime(Actual_WorkingData.WorkingYear, Actual_WorkingData.WorkingMonth, WOY.MondayDate.Day));// Convert.ToInt32(Txt_Day.Text)));
                    SendEvent = false;
                    break;
            }

            if (SendEvent == true) { OnFilterSelectionChangedEvent(oEvent); }
        }

        /// <summary>
        /// Reset the Check Flag
        /// </summary>
        protected void ResetRadioButtons()
        {
            Radio_Today.Checked = false;
            RadioTomorrow.Checked = false;
            RadioUntilTomorrow.Checked = false;
            Radio_ThisWeek.Checked = false;
        }

        /// <summary>
        /// Make it Thread Safe
        /// </summary>
        /// <param name="e"></param>
        protected void OnFilterSelectionChangedEvent(Objects.oBufLeftDockedFilterSelectionEvent e)
        {
            if (FilterSelectionChangedEvent != null)
            {
                FilterSelectionChangedEvent(this, e);
            }
        }

        private void Grp_Days_Click(object sender, EventArgs e)
        {
            ResetRadioButtons();
            Grp_Days.BackColor = System.Drawing.Color.LightSteelBlue; Grp_Weeks.BackColor = System.Drawing.Color.FromName("@window");
        }

        private void btn_PrevDay_Click(object sender, EventArgs e)
        {
            ResetRadioButtons();
            Grp_Days.BackColor = System.Drawing.Color.LightSteelBlue; Grp_Weeks.BackColor = System.Drawing.Color.FromName("@window");
            Scroll2NewDate(Actual_WorkingData.WorkingDate.AddDays(-1));
        }

        private void btn_NextDay_Click(object sender, EventArgs e)
        {
            ResetRadioButtons();
            Grp_Days.BackColor = System.Drawing.Color.LightSteelBlue; Grp_Weeks.BackColor = System.Drawing.Color.FromName("@window");
            Scroll2NewDate(Actual_WorkingData.WorkingDate.AddDays(1));
        }

        private void Txt_Day_Click(object sender, EventArgs e)
        {
            ResetRadioButtons();
            Grp_Days.BackColor = System.Drawing.Color.LightSteelBlue; Grp_Weeks.BackColor = System.Drawing.Color.FromName("@window");
            Txt_Day.SelectAll();
        }
        private void Txt_Day_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (Txt_Day.Text.Length >= 2)
            {
                if (Grp_Days.BackColor == System.Drawing.Color.LightSteelBlue)
                {
                    Scroll2NewDate(new DateTime(Actual_WorkingData.WorkingYear, Actual_WorkingData.WorkingMonth, Convert.ToInt32(Txt_Day.Text)));
                }
            }
        }

        private void Grp_Weeks_Click(object sender, EventArgs e)
        {
            ResetRadioButtons();
            Grp_Weeks.BackColor = System.Drawing.Color.LightSteelBlue; Grp_Days.BackColor = System.Drawing.Color.FromName("@window");
        }

        private void btn_PrevWeek_Click(object sender, EventArgs e)
        {
            ResetRadioButtons();
            Grp_Weeks.BackColor = System.Drawing.Color.LightSteelBlue; Grp_Days.BackColor = System.Drawing.Color.FromName("@window");
            GDYR.LULM.LMObjects.Common.Dates.oWeek.oWeekOfYear W= GDYR.LULM.LMObjects.Common.Dates.oWeek.getCurrentWeek(Actual_WorkingData.WorkingDate.AddDays(-7));
            Scroll2NewDate(Actual_WorkingData.WorkingDate = W.MondayDate);
        }

        private void btn_NextWeek_Click(object sender, EventArgs e)
        {
            ResetRadioButtons();
            Grp_Weeks.BackColor = System.Drawing.Color.LightSteelBlue; Grp_Days.BackColor = System.Drawing.Color.FromName("@window");
            Scroll2NewDate(Actual_WorkingData.WorkingDate = Actual_WorkingData.WorkingDate.AddDays(7));
        }

        private void Txt_Week_Click(object sender, EventArgs e)
        {
            ResetRadioButtons();
            Grp_Weeks.BackColor = System.Drawing.Color.LightSteelBlue; Grp_Days.BackColor = System.Drawing.Color.FromName("@window");
            Txt_Week.SelectAll();
        }

        private void Txt_Week_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (Txt_Week.Text.Length >= 2)
            {
                if (Grp_Weeks.BackColor == System.Drawing.Color.LightSteelBlue)
                {
                    Scroll2NewDate(GDYR.LULM.LMObjects.Common.Dates.oWeek.GetMondayOfWeekISO8601(Actual_WorkingData.WorkingYear, Convert.ToInt32(Txt_Week.Text)));
                }
            }
        }

        /// <summary>
        /// Check if the supplied string is a valid date (like 31th of February isn't valid)
        /// </summary>
        /// <param name="obj"></param>
        /// <returns></returns>
        public static bool IsDate(Object obj)
        {
            string strDate = obj.ToString();
            try
            {
                DateTime dt = DateTime.Parse(strDate);
                if (dt != DateTime.MinValue && dt != DateTime.MaxValue)
                    return true;
                return false;
            }
            catch
            {
                return false;
            }
        }

        /// <summary>
        /// Scroll the days back or forward
        /// </summary>
        /// <param name="Days">Positive or negative value</param>
        public Objects.oBufLeftDockedFilterSelectionEvent Scroll2NewDate(DateTime NewDate)
        {
            //Display Wait cursor - Will be reset be the Event Handler
            Cursor = Cursors.WaitCursor;

            Objects.oBufLeftDockedFilterSelectionEvent oReturn = new Objects.oBufLeftDockedFilterSelectionEvent();
            Actual_WorkingData = WorkingOn.GetWorkingData(NewDate);
            //Get the Actual Day
            if (Txt_Day.Focus())
            {
            Txt_Day.Text = Actual_WorkingData.WorkingDate.Day.ToString().PadLeft(2,'0');
            }
            else
            {
                Txt_Day.Text = Actual_WorkingData.WorkingDate.Day.ToString().PadLeft(2, '0');
                Txt_Day.SelectAll();
            }

            //Get Actual Month
            Grp_Days.Text = "Days (" + Actual_WorkingData.WorkingDate.ToString("MMMM") + ")";

            //Set Actual Year
            Grp_Weeks.Text = "Weeks (" + Actual_WorkingData.WorkingYear + ")";

            if (Txt_Week.Focus())
            {
            Txt_Week.Text = Actual_WorkingData.WorkingWeek.ToString().PadLeft(2, '0');
                Txt_Week.SelectAll();
            }
            else
            {
                Txt_Week.Text = Actual_WorkingData.WorkingWeek.ToString().PadLeft(2, '0');
            }

            if (Grp_Days.BackColor == System.Drawing.Color.LightSteelBlue)
            {
            //Set the Date Range Boundaries for a single Date
            oReturn.DateRangeStart = Actual_WorkingData.WorkingDate;
            oReturn.DateRangeEnd = Actual_WorkingData.WorkingDate;
                oReturn.EventText = "(Week " + Actual_WorkingData.WorkingWeek + " : " + Actual_WorkingData.WorkingYear + " " + Actual_WorkingData.WorkingDate.ToString("MMMM") + " " + Txt_Day.Text + ")";
            }
            else
            {
                //Set the Date Range Boundaries for a a Week
                DateTime WeekMonday = GDYR.LULM.LMObjects.Common.Dates.oWeek.GetMondayOfWeekISO8601(Actual_WorkingData.WorkingYear, Convert.ToInt32(Txt_Week.Text));
                oReturn.DateRangeStart = WeekMonday;
                oReturn.DateRangeEnd = WeekMonday.AddDays(6);
                oReturn.EventText = "(Week " + Actual_WorkingData.WorkingWeek + " : " + oReturn.DateRangeStart.ToShortDateString() + " - " + oReturn.DateRangeEnd.ToShortDateString() + ")";
            }

            oReturn.OnlyLate = Chk_LateOnly.Checked;

            OnFilterSelectionChangedEvent(oReturn);

            return oReturn;
        }
        public static class WorkingOn
        {
            public class WorkingData
            {
                DateTime _WorkingDate = DateTime.MinValue;
                public DateTime WorkingDate
                {
                    get { return _WorkingDate; }
                    set
                    {
                        _WorkingDate = value;
                        WorkingDay = value.Day;
                        WorkingMonth = value.Month;
                        WorkingYear = value.Year;
                    }
                }
                public int WorkingDay { get; set; }
                public int WorkingMonth { get; set; }
                public int WorkingWeek { get; set; }
                public int WorkingYear { get; set; }
            }

            public static WorkingData GetWorkingData(DateTime _Date)
            {
                WorkingData oReturn = new WorkingData();
                oReturn.WorkingDate = _Date;
                oReturn.WorkingDay = _Date.Day;
                oReturn.WorkingMonth = _Date.Month;

                GDYR.LULM.LMObjects.Common.Dates.oWeek.oWeekOfYear WOfY = GDYR.LULM.LMObjects.Common.Dates.oWeek.getCurrentWeek(_Date);
                oReturn.WorkingWeek = WOfY.Week;
                oReturn.WorkingYear = WOfY.Year;

                return oReturn;
            }
        }
    }
}
