﻿using System;
using System.Collections.Generic;
using Wisej.Web;
using System.Data; //Required for LINQ queries

namespace GDYR.LULM.Wj.ProdManager.UserControls
{
    public partial class UC_OperationDetails : Wisej.Web.UserControl
    {
        //GDYR.LULM.Wj.ProdManager.Engines.eControlColorer CtrlColorer = null;

        //To hold the width of all the Operation Controls
        private int _TotalOperationsWidth;
        public int TotalOperationsWidth
        {
            get
            {
                return _TotalOperationsWidth;
            }
            set
            {
                _TotalOperationsWidth = value;
            }
        }

        SortedList<int, string> oDesc = new SortedList<int, string>();

        public UC_OperationDetails()
        {
            InitializeComponent();
        }
        public UC_OperationDetails(String Header, List<KeyValuePair<string,string>> Operdic,System.Collections.Specialized.NameValueCollection OperDescDic, Objects.oUC_1BufRow_Data oUC_1BufRowData)
        {
            InitializeComponent();

            //CtrlColorer = new Engines.eControlColorer();

            this.SuspendLayout();

            UC_TriggerDates1.Lbl_T1.Text = "07/28";
            UC_TriggerDates1.Lbl_T2.Text = "08/03";

            UC_TriggerDates1.Lbl_T4.Text = "08/23";
            UC_TriggerDates1.Lbl_T5.Text = "09/10";

            //Store the Triggers into the Data Object
            oUC_1BufRowData.OperationDetails.Triggers = new List<string>();
            oUC_1BufRowData.OperationDetails.Triggers.Add(UC_TriggerDates1.Lbl_T1.Text);
            oUC_1BufRowData.OperationDetails.Triggers.Add(UC_TriggerDates1.Lbl_T2.Text);
            oUC_1BufRowData.OperationDetails.Triggers.Add(UC_TriggerDates1.Lbl_T3.Text);
            oUC_1BufRowData.OperationDetails.Triggers.Add(UC_TriggerDates1.Lbl_T4.Text);
            oUC_1BufRowData.OperationDetails.Triggers.Add(UC_TriggerDates1.Lbl_T5.Text);

            this.Controls.Add(UC_TriggerDates1);

            Label Lbl_Header = new Label();
            Lbl_Header.Font= new System.Drawing.Font("default", 13F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Pixel);
            Lbl_Header.Dock = Wisej.Web.DockStyle.Top;
            Lbl_Header.Text = Header;
            toolTip_Header.SetToolTip(Lbl_Header, Header);

            //Store the OperationDetails Header into the Data Object
            oUC_1BufRowData.OperationDetails.Header = Lbl_Header.Text;

            this.Controls.Add(Lbl_Header);
            this.Controls.SetChildIndex(Lbl_Header, 0);

            _TotalOperationsWidth = UC_TriggerDates1.Width; //Initialize the TotalWidth to the first Control (Dates)

            oUC_1BufRowData.OperationDetails.OperRows = new List<Objects.oUC_1BufRow_Data._OperRow>();
            foreach (KeyValuePair<string, string> entry in Operdic)
            {
                UC_WKC_OpNr WKC_OpNr = new UC_WKC_OpNr();
                WKC_OpNr.SuspendLayout();

                WKC_OpNr.Lbl_WKC.Text = entry.Key;
                WKC_OpNr.Lbl_Operation.Text = entry.Value.TrimStart('0');
                WKC_OpNr.Lbl_OperDesc.Text = OperDescDic[entry.Value].Substring(0, 4); // oDesc.Values[NbrOperations].Substring(0,4);
                WKC_OpNr.SetToolTip_Desc = OperDescDic[entry.Value]; // oDesc.Values[NbrOperations];

                //Store the WKC_OpNr details into the Data Object
                oUC_1BufRowData.OperationDetails.OperRows.Add(new Objects.oUC_1BufRow_Data._OperRow {OpNr = WKC_OpNr.Lbl_Operation.Text,
                                                                                                     OpWKC = WKC_OpNr.Lbl_WKC.Text,
                                                                                                     OpDesc = WKC_OpNr.Lbl_OperDesc.Text});

                //Let's conditional Color the Operation
                //CtrlColorer.Color_UserControl(WKC_OpNr, DS_PO);

                WKC_OpNr.Dock = DockStyle.Left;
                this.Controls.Add(WKC_OpNr);
                this.Controls.SetChildIndex(WKC_OpNr, 0);

                _TotalOperationsWidth += WKC_OpNr.Width;

                WKC_OpNr.ResumeLayout();

                //Wisej.Web.StyleSheet mStyleSheet = this.styleSheet1;
                //Label Lbl_WKC = new Wisej.Web.Label();
                //Lbl_WKC.Text = entry.Key;
                //Lbl_WKC.Size = new System.Drawing.Size(10, 50);
                //Lbl_WKC.Font = new System.Drawing.Font("courier", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Pixel);
                //mStyleSheet.SetCssClass(Lbl_WKC, "rotated270");
                //Lbl_WKC.TextAlign = System.Drawing.ContentAlignment.BottomRight; 
                //Lbl_WKC.Dock = DockStyle.Left;
                //this.Controls.Add(Lbl_WKC);
                //this.Controls.SetChildIndex(Lbl_WKC, 0);
            }

            this.Width = _TotalOperationsWidth;

            this.ResumeLayout();

            //CtrlColorer = null;
        }

        private void UC_OperationDetails_Load(object sender, EventArgs e)
        {

        }

        /// <summary>
        /// Resize the control to only the width of displayed Operation
        /// </summary>
        public void ResizeCtrl(int TotalWidth=0)
        {
            if (TotalWidth == 0)
            {
                //Initialize the width, starting with the left Uc control used to display the trigger dates
                TotalWidth = UC_TriggerDates1.Width;
                foreach (Wisej.Web.Control Ctrl in this.Controls)
                {
                    if (Ctrl.Name.Contains("UC_WKC_OpNr"))
                    {
                        TotalWidth += Ctrl.Width;
                    }
                }

            }

            this.SuspendLayout();

            this.Width = TotalWidth;
            this.Refresh();

            this.ResumeLayout();
        }

        /// <summary>
        /// Region Bubble The Click Event
        /// </summary>
        /// <param name="e"></param>
        #region To Bubble the Click Event
        protected override void OnControlAdded(ControlEventArgs e)
        {
            e.Control.Click += doclick;
            e.Control.MouseEnter += doMouseEnter;
        }

        private void doclick(object sender, EventArgs e)
        {
            this.OnClick(e);
        }
        private void doMouseEnter(object sender, EventArgs e)
        {
            this.OnMouseEnter(e);
        }

        protected override void OnControlRemoved(ControlEventArgs e)
        {
            e.Control.Click -= doclick;
            e.Control.MouseEnter -= doMouseEnter;
        }
        #endregion

        public UC_OperationDetails CreateCopy()
        {
            UC_OperationDetails oReturn = new UC_OperationDetails();
            Label Lbl_Header = new Label();
            Lbl_Header.Font = new System.Drawing.Font("default", 13F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Pixel);
            Lbl_Header.Dock = Wisej.Web.DockStyle.Top;
            Lbl_Header.Text = "Header";
            toolTip_Header.SetToolTip(Lbl_Header, "Header");
            
            oReturn.Controls.Add(Lbl_Header);

            foreach (object Ctrl in this.Controls)
            {
                if (Ctrl is UserControls.UC_WKC_OpNr)
                {
                    UserControls.UC_WKC_OpNr UC = (UserControls.UC_WKC_OpNr)Ctrl;
                    foreach (Wisej.Web.Label Lbl in UC.Controls)
                    {
                        Wisej.Web.Label L = new Label();
                        L.AutoSize = false;
                        L.Text = Lbl.Text;
                        L.Location = Lbl.Location;
                        L.Size = Lbl.Size;

                        oReturn.Controls.Add(L);
                    }
                }
                else if (Ctrl is Wisej.Web.Label)
                {
                    //oReturn.
                }
            }
            return oReturn;
        }
    }
}
