﻿using System;
using Wisej.Web;

namespace GDYR.LULM.Wj.ProdManager.UserControls
{
    public partial class UP_ProductionOrder : Wisej.Web.UserPopup
    {
        public delegate void ItemSelectedHandler(object sender, Objects.oBufItemSelectedEventArg e);

        public event ItemSelectedHandler ItemSelectedEvent;

        bool _ByProductionOrder;
        public bool ByProductionOrder {
             set {
                _ByProductionOrder = value;
                if (value == true)
                {
                    _BySalesOrder = false;
                    Layout_ByProductionOrder();
                }
                else
                {
                    listView1.Columns.Clear();
                }
            }
            get
            {
                return _ByProductionOrder;
            }
        }

        bool _BySalesOrder;
        public bool BySalesOrder
        {
            set
            {
                _BySalesOrder = value;
                if (value == true)
                {
                    _ByProductionOrder = false;
                    Layout_BySalesOrder();
                }
                else
                {
                    listView1.Columns.Clear();
                }
            }
            get
            {
                return _BySalesOrder;
            }
        }
        public UP_ProductionOrder()
        {
            InitializeComponent();
        }
        void Layout_ByProductionOrder()
        {
            this.listView1.Columns.Clear();
            this.listView1.Columns.Add("Sales Order",150,HorizontalAlignment.Left);
            this.listView1.Columns.Add("Prod. Order", 130, HorizontalAlignment.Left);
        }
        void Layout_BySalesOrder()
        {
            this.listView1.Columns.Clear();
            this.listView1.Columns.Add("Sales Order", 250, HorizontalAlignment.Left);
            //listView1.Columns.Add("Prod. Order", 100, HorizontalAlignment.Left);
        }
        /// <summary>
        /// Clear from the last Search result
        /// </summary>
        public void Clear()
        {
            this.listView1.Items.Clear();
        }

        /// <summary>
        /// Fill GUI with results
        /// </summary>
        /// <param name="DS"></param>
        public void Fill(System.Data.DataSet DS)
        {
            Clear();

            foreach (System.Data.DataRow DR in DS.Tables[0].Rows)
            {
                switch (DS.Tables[0].Columns.Count)
                {
                    case 2://BySalesOrder
                        ListViewItem LVI_SO = new ListViewItem(DR[0].ToString() + "-" + DR[1].ToString().TrimStart('0'));
                        LVI_SO.BackColor = System.Drawing.Color.Khaki;
                        listView1.Items.Add(LVI_SO);
                        break;

                    case 3://ByProductionOrder
                        ListViewItem LVI_PO = new ListViewItem(DR[0].ToString() + "-" + DR[1].ToString().TrimStart('0'));
                        LVI_PO.BackColor = System.Drawing.Color.Khaki;
                        LVI_PO.SubItems.Add(DR[2].ToString().TrimStart('0'));
                        LVI_PO.SubItems[1].BackColor = System.Drawing.Color.Khaki;
                        listView1.Items.Add(LVI_PO);
                        break;
                }
            }
        }

        /// <summary>
        /// ByProductionOrder > Only supply PO / BySalesOrder > Only supply SO
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void listView1_ItemClick(object sender, ItemClickEventArgs e)
        {
            Objects.oBufItemSelectedEventArg eArg = new Objects.oBufItemSelectedEventArg();
            if (_ByProductionOrder == true)
            {
                //eArg.SalesOrder =listView1.SelectedItems[0].Text;
                eArg.ProductionOrder = listView1.SelectedItems[0].SubItems[1].Text;
                eArg.SalesOrder = "";
            }
            else if (_BySalesOrder == true)
            {
                eArg.SalesOrder = listView1.SelectedItems[0].Text;
                eArg.ProductionOrder = "";
            }

            //Raise Event (in a Thread Safe manner)
            OnItemSelectedEvent(eArg);
        }

        /// <summary>
        /// Make it Thread Safe
        /// </summary>
        /// <param name="e"></param>
        protected void OnItemSelectedEvent(Objects.oBufItemSelectedEventArg e)
        {
            if (ItemSelectedEvent != null)
            {
                ItemSelectedEvent(this, e);
            }
        }
    }
}
